
%define debug_package		%{nil}

%define VirtualEnvironment      $HOME/PythonVirtualEnvironments/%{name}

Summary:	docker-forensics-toolkit - toolkit for performing post-mortem analysis of Docker runtime environments

Packager:	Lawrence R. Rogers (lrr@cert.org)

Vendor:		cert.org
Name:		docker-forensics-toolkit
Version:	0.2.0
Release:	2%{?dist}
URL:		https://github.com/docker-forensics-toolkit/toolkit

License:	ASL 2

Group:		Applications/Forensics Tools
Source:		%{name}-%{version}.tar.gz

BuildRoot:	%{_tmppath}/rpm-root-%{name}-v%{version}
BuildRequires:	python%{python3_pkgversion}-virtualenv
BuildRequires:	upx

%description
This package contains a toolkit for performing post-mortem analysis of Docker runtime environments based on forensic HDD copies of the docker host system.

Features:
 * mount-image - Mounts the forensic image of the docker host
 * status - Prints status information about the container runtime
 * list-images - Prints images found on the computer
 * show-image-history - Displays the build history of an image
 * show-image-config - Pretty prints the full config file of an image
 * list-containers - Prints containers found on the computer
 * show-container-log - Displays the latest container logfiles
 * show-container-config - Pretty prints the combined container specific config files (config.v2.json and hostconfig.json).
 * mount-container - Mounts the file system of a given container at the given location (overlay2 only)
 * macrobber-container-layer - Extracts file system metadata from the container layer of the given container. Use the output with the 'mactime' tool to create a timeline.
 * macrobber-volumes - Extracts file system metadata from the volumes of the given container. Use the output with the 'mactime' tool to create a timeline.
 * carve-for-deleted-docker-files - Carves the image for deleted Docker files, such as container configs,Dockerfiles and deleted log files. Requires 'scalpel' to be installed.

%prep
%setup 

%build
%if 0%{?centos} == 7 || 0%{?fedora} == 28 || 0%{?fedora} == 27
[ -d %{VirtualEnvironment} ] || virtualenv-3 -q %{VirtualEnvironment}
%else
[ -d %{VirtualEnvironment} ] || virtualenv -q %{VirtualEnvironment}
%endif
sh -c "source %{VirtualEnvironment}/bin/activate; pip3 install pyinstaller termcolor argcomplete imagemounter; pyinstaller -F dof.spec"
rm -rf  %{VirtualEnvironment}

%install
%{__install} -Dp -m755 dist/dof %{buildroot}%{_bindir}/dof

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc README.md USAGE.md
%{_bindir}/*

%changelog
* Mon Jun 29 2020 Lawrence R. Rogers <lrr@cert.org> 0.2.0-1
* Release 0.2.0-1
	Version 0.2.0 - initial release

